local paradiseillusion = CV_RegisterVar({
	--Toggles the normal meat palace to something nicer.
	--Swaps several flats/textures and disables dynamic slopes.
	name = "paradiseillusion",
	defaultvalue = "Never",
	flags = CV_NETVAR,
	possiblevalue = {Off = 0, On = 1, Never = 2, Always = 3}
})


addHook("MapLoad", function(mapnum)
	if not mapheaderinfo[gamemap].trueparadise == true
		return
	end
	if 	((paradiseillusion.value == 1 or paradiseillusion.value == 0) and encoremode == true) or (paradiseillusion.value == 3)
		P_LinedefExecute(1997) --Executor that supresses encore sky channge.
	end
	
	if (paradiseillusion.value == 1 and encoremode == true) or (paradiseillusion.value == 0)
		or (paradiseillusion.value == 2)
		--See what you are missing in Encore mode.
		return
	end

	--Moving Replacement
	P_SetupLevelSky(29, true)
	--Change Music/ Moving flats
	P_LinedefExecute(1999)
	--Flat Replacement
	for s in sectors.iterate
		s.lightlevel = $1 + 48
		if s.floorpic == "FLPDFLWR"
			s.floorpic = "JNGGRS11"
		elseif s.floorpic == "FLPDGRS"
			s.floorpic = "JNGGRS03"
		elseif s.floorpic == "FLPDWDF"
			s.floorpic = "JNGWDFC"
		elseif s.floorpic == "NTFLAT10"
			s.floorpic = "STONEF1"
		elseif s.floorpic == "NTFLAT9"
			s.floorpic = "OMRBLQ00"
		elseif s.floorpic == "OFLSHB02"
			s.floorpic = "OMRBLL01"
		elseif s.floorpic == "OFLSHF01"
			s.floorpic = "STONEF2"
		elseif s.floorpic == "OHELLA02"
			s.floorpic = "ROCKFLR4"
		elseif s.floorpic == "OHELLA03"
			s.floorpic = "ROCKFLR2"
		elseif s.floorpic == "OLAVAD01"
			s.floorpic = "PG_WATER"
		elseif s.floorpic == "VISNAKF3"
			s.floorpic = "SPROCF2"
		elseif s.floorpic == "VSNAKF41"
			s.floorpic = "OMRBLL33"
		elseif s.floorpic == "VSNAKF42"
			s.floorpic = "SPROCF1"
			end
		--Ceilings too
		if s.ceilingpic == "FLPDFLWR"
			s.ceilingpic = "JNGGRS11"
		elseif s.ceilingpic == "FLPDGRS"
			s.ceilingpic = "JNGGRS03"
		elseif s.ceilingpic == "FLPDWDF"
			s.ceilingpic = "JNGWDFC"
		elseif s.ceilingpic == "NTFLAT10"
			s.ceilingpic = "STONEF1"
		elseif s.ceilingpic == "NTFLAT9"
			s.ceilingpic = "OMRBLQ00"
		elseif s.ceilingpic == "OFLSHB02"
			s.ceilingpic = "OMRBLL01"
		elseif s.ceilingpic == "OFLSHF01"
			s.ceilingpic = "STONEF2"
		elseif s.ceilingpic == "OHELLA02"
			s.ceilingpic = "ROCKFLR4"
		elseif s.ceilingpic == "OHELLA03"
			s.ceilingpic = "ROCKFLR2"
		elseif s.ceilingpic == "OLAVAD01"
			s.ceilingpic = "PG_WATER"
		elseif s.ceilingpic == "VISNAKF3"
			s.ceilingpic = "SPROCF2"
		elseif s.ceilingpic == "VSNAKF41"
			s.ceilingpic = "OMRBLL33"
		elseif s.ceilingpic == "VSNAKF42"
			s.ceilingpic = "SPROCF1"
		end
	end
	
	local function textureswap(l,old,swap)
		if (l.special == 439)
				return
		end

		--Front side
		local this = l.frontside
		if (this.toptexture == old) this.toptexture = swap end
		if (this.midtexture == old ) this.midtexture = swap end
		if (this.bottomtexture == old) this.bottomtexture = swap end

		if l.backside == nil
			return --One-sided stops here.
		end

		--Back side
		local this = l.backside;
		if (this.toptexture == old) this.toptexture = swap end
		if (this.midtexture == old) this.midtexture = swap end
		if (this.bottomtexture == old ) this.bottomtexture = swap end
	end
	
	for l in lines.iterate
		--Disable Dynamic Vslopes. Ideal method, but need to stop floor movement.
			--[[if l.special == 799
				l.frontsector.tag = 0
				--P_RemoveThinker(l.frontsector)
				l.frontsector.floordata = NULL
				l.frontsector.ceilingdata = NULL
				l.frontsector.floorspeed = 0 
				l.frontsector.ceilspeed = 0]]
			if l.special == 54
					l.frontsector.ceilingheight = l.backsector.ceilingheight
					l.frontsector.floorheight = l.backsector.floorheight
		--Silence Goo
			elseif l.special == 414 and l.frontside.toptexture == _G["sfx_ghit"] 
				l.frontside.toptexture = _G["sfx_none"]
		--Move Invis Goo
			elseif l.special == 259 
			--and l.backside.toptexture == 200061
				l.frontsector.floorheight = -9000*FRACUNIT
				l.frontsector.ceilingheight = -9000*FRACUNIT
			end
			
		--Swap textures
			textureswap(l,R_TextureNumForName("FLPDGRSW"),R_TextureNumForName("JNGGRW3"))
			textureswap(l,R_TextureNumForName("FLPDGRW"),R_TextureNumForName("JNGGRW7S"))
			textureswap(l,R_TextureNumForName("FLPDWD"),R_TextureNumForName("JNGWD8"))
			textureswap(l,R_TextureNumForName("SKINRAIL"),R_TextureNumForName("OFENCB01"))
			textureswap(l,R_TextureNumForName("OFALLM01"),R_TextureNumForName("CFALL1"))
			textureswap(l,R_TextureNumForName("OFLSHB01"),R_TextureNumForName("GSTONE1"))
			textureswap(l,R_TextureNumForName("OFLSHC01"),R_TextureNumForName("OMRBLQ43"))
			textureswap(l,R_TextureNumForName("OFLSHE01"),R_TextureNumForName("SHALE2"))
			textureswap(l,R_TextureNumForName("OFLSHF01"),R_TextureNumForName("STONEW2"))
			textureswap(l,R_TextureNumForName("OFLSHG01"),R_TextureNumForName("CLIFFW7S"))
			textureswap(l,R_TextureNumForName("SCYPFWL2"),R_TextureNumForName("SPWALL1"))
			textureswap(l,R_TextureNumForName("SKIN2"),R_TextureNumForName("OMRBLQ00"))
			textureswap(l,R_TextureNumForName("SKINFLE1"),R_TextureNumForName("PHZWALL"))
			textureswap(l,R_TextureNumForName("SKINFLE2"),R_TextureNumForName("STONEW1"))
			textureswap(l,R_TextureNumForName("OMRBLO29"),R_TextureNumForName("MMAZE6"))
			textureswap(l,R_TextureNumForName("VISNAKE3"),R_TextureNumForName("SPWALL2"))
			textureswap(l,R_TextureNumForName("VSNAKE41"),R_TextureNumForName("SHALE1"))
			textureswap(l,R_TextureNumForName("VSNAKE42"),R_TextureNumForName("SPWALL1"))
			--textureswap(l,R_TextureNumForName(""),R_TextureNumForName(""))
	end
end)

local oldparavar
local function illusionvars(net)
	oldparavar = net($)
end

addHook("ThinkFrame",function() --Hacky method to supress encore when illusion is on or off.
	if not (mapheaderinfo[gamemap].trueparadise == true) and not (paradiseillusion.value == 1 or paradiseillusion.value == 0)
		or(encoremode == false)
	
		return
	end
	--Using flashpals in encore did not work as intended; the palette would always be a
	--default one (%75 tinted white)
	--[[for p in players.iterate
		P_FlashPal(p,7,1)
	end]]
	--Reload the map instead
	if leveltime == 1
		oldparavar = paradiseillusion.value
		local changeval
		if paradiseillusion.value == 1
			changeval = 2
		end
		if paradiseillusion.value == 0
			changeval = 3
		end
		COM_BufInsertText(server, "kartencore off")
		COM_BufInsertText(server, "paradiseillusion "..changeval)
		--[[G_SetCustomExitVars(gamemap, 1)
		G_ExitLevel()]]
		COM_BufInsertText(server, "map "..gamemap)
		COM_BufInsertText(server, "wait 1")
		COM_BufInsertText(server, "paradiseillusion "..oldparavar)
	end
end)

--Kirby sky and textures on centerpiece. Shoutouts to RoyKirbs for Kirby plush Textures.
local function kirbMake(l,mo)
	P_SetupLevelSky(1126, true)
	for s in sectors.iterate
	 if s.floorpic == "VSNAKF41" or s.floorpic == "OMRBLL33"
		s.floorpic = "KRBCHKR"
	 end
	 if s.ceilingpic == "VSNAKF41" or s.ceilingpic == "OMRBLL33"
		s.ceilingpic = "KRBCHKR"
	 end
	end
end
addHook("LinedefExecute", kirbMake,"KIRBYFY")

--Modifies Things
local function thingEdit()
	--Thing edits. Removes fog and dripping water; also changes plant colors.
	for mo in thinkers.iterate("mobj")
		if mo.type == MT_WATERDRIP or mo.type == MT_EERIEFOG or mo.type == MT_EERIEFOGGEN
			P_RemoveMobj(mo)
		elseif mo.type == MT_FPARADISEBUSH
			mo.color = SKINCOLOR_WALNUT
		elseif mo.type == MT_FPARADISEFLOWER
			mo.color = SKINCOLOR_TEA
		end
	end
end
addHook("LinedefExecute", thingEdit,"FPMOD")